<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dbdownload extends MX_Controller {

    /**
     * Index Page for this controller.
     *
     * Past the login page this loads the page for /mysql/dbdownload.
     *
     */

    public function index() {

        $CI =& get_instance();

        // We load the BlueOnyx helper library first of all, as we heavily depend on it:
        $this->load->helper('blueonyx');
        init_libraries();

        // Need to load 'BxPage' for page rendering:
        $this->load->library('BxPage');

        // Get $CI->BX_SESSION['sessionId'] and $CI->BX_SESSION['loginName'] from Cookie (if they are set):
        $CI->BX_SESSION['sessionId'] = $CI->input->cookie('sessionId');
        $CI->BX_SESSION['loginName'] = $CI->input->cookie('loginName');
        
        // Line up the ducks for CCE-Connection:
        include_once('ServerScriptHelper.php');
        $CI->serverScriptHelper = new ServerScriptHelper($CI->BX_SESSION['sessionId'], $CI->BX_SESSION['loginName']);
        $CI->cceClient = $CI->serverScriptHelper->getCceClient();
        $user = $CI->BX_SESSION['loginUser'];
        $i18n = new I18n("base-mysql", $CI->BX_SESSION['loginUser']['localePreference']);
        $system = $CI->getSystem();

        // Initialize Capabilities so that we can poll the access rights as well:
        $Capabilities = new Capabilities($CI->cceClient, $CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);

        // -- Actual page logic start:

        //
        //--- Get CODB-Object of interest: 
        //

        // We get our $get_form_data early, to make sure nobody is messing with us.
        // Depending on what we modify, we have the "group", "action" and "db" information on the URL string - or not.

        $get_form_data = $CI->input->get(NULL, TRUE);

        if ((!isset($get_form_data['group'])) || (!isset($get_form_data['action'])) || (!isset($get_form_data['db']))) {
            $get_form_data['group'] = '';
        }

        if (isset($get_form_data['group'])) {
            // We have a delete transaction:
            $group = $get_form_data['group'];
        }
        else {
            // Don't play games with us!
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#1");
        }

        //
        //-- Access Rights Check for Vsite level pages:
        // 
        // 1.) Checks if the Group/Vsite exists.
        // 2.) Checks if the user is systemAdministrator
        // 3.) Checks if the user is Reseller of the given Group/Vsite
        // 4.) Checks if the iser is siteAdmin of the given Group/Vsite
        // Returns Forbidden403 if *none* of that is the case.
        if (!$Capabilities->getGroupAdmin($group)) {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#2");
        }

        if (isset($get_form_data['db'])) {
            $db_name = $get_form_data['db'];
        }

        if (isset($get_form_data['action'])) {
            $action = $get_form_data['action'];
        }

        // If 'action' is not set correctly, redirect to previous page. 
        // We do have $group or we wouldn't be here.
        $possible_actions = array('up', 'load', 'back', 'down', 'waup', 'waload', 'waback', 'wadown');
        if (!in_array($action, $possible_actions)) {
            // Redirect to previous the page:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();          
            header("Location: /mysql/vsiteMySQL?group=" . $group);
            exit;
        }

        //
        //-- Prepare data:
        //

        // Get data for the Vsite:
        $vsite = $CI->cceClient->getObject('Vsite', array('name' => $group));

        // Get the MySQL settings for this Vsite:
        $vsite_MySQL = $CI->cceClient->get($vsite['OID'], "MYSQL_Vsite");

        // Get PHPVsite for this Vsite:
        $PHPVsite = $CI->cceClient->get($vsite['OID'], "PHPVsite");

        // Get the existing MySQL data from CODB's "System" object:
        $SystemMYSQL = $CI->cceClient->get($system['OID'], "mysql");

        // Get the existing "MySQL" Object:
        $AbsMYSQL = $CI->cceClient->getObject("MySQL");

        // Get Array of extra MySQL databases:
        $mysql_databases_extra = $CI->cceClient->scalar_to_array($vsite_MySQL['DBmulti']);

        //
        //-- DB Name-Check:
        //

        $WA_dbs = array();
        $BX_dbs = array();

        // For WebApps:
        if ($action == 'wadown') {
            $NWA_dbList = array();
            $num_nwa_dbs = '0';
            $WebApps_Vsite = $CI->cceClient->find("WebApplications", array('group' => $group));
            if (count($WebApps_Vsite) > '0') {
                $ret = ini_set("display_errors", "Off");
                $mysql_link = new mysqli($AbsMYSQL['sql_host'], $AbsMYSQL['sql_root'], $AbsMYSQL['sql_rootpassword']);

                if ($system['productBuild'] == '5210R') {
                    $sql_exportDir = $vsite['basedir'] . '/wwwroot/webapps_backup/';
                }
                else {
                    $sql_exportDir = $vsite['basedir'] . '/webapps_backup/';
                }
                $vsite_group = $vsite['name'];

                // Prepar WebApp DB's for presentation:
                foreach ($WebApps_Vsite as $key => $oid) {
                    $WA = $CI->cceClient->get($oid);
                    if (!$mysql_link->connect_error) {
                        if (mysqli_select_db($mysql_link, $WA['sqldb'])) {
                            $WA_dbs[] = $WA['sqldb'];
                        }
                        else {
                            // Someone tried to request an action for a file for a DB that doesn't exist yet. 
                            // Nice people say goodbye, or CCEd waits forever:
                            $CI->cceClient->bye();
                            $CI->serverScriptHelper->destructor();
                            Log403Error("/gui/Forbidden403#3");
                        }
                    }
                }
                @mysqli_close($mysql_link);
                $ret = ini_set("display_errors", "On");
            }
        }

        // For regular DBs:
        if ($action == 'down') {
            $BX_dbs[] = $vsite_MySQL['DB'];
            if (is_array($mysql_databases_extra)) {
                foreach ($mysql_databases_extra as $key => $extra_db_name) {
                    $BX_dbs[] = $extra_db_name;
                }
            }
        }

        // Check if DB exists:
        if (($action == 'wadown') && (!in_array($db_name, $WA_dbs))) {
            // Someone tried to request an action for a file for a DB that doesn't exist yet. 
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#4");
        }

        if (($action == 'down') && (!in_array($db_name, $BX_dbs))) {
            // Someone tried to request an action for a file for a DB that doesn't exist yet. 
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#5");
        }


        //
        //-- Path Setups:
        //

        if ($system['productBuild'] == '5210R') {
            if ($action == 'wadown') {
                $sql_exportDir = $vsite['basedir'] . '/wwwroot/webapps_backup/';
            }
            else {
                $sql_exportDir = $vsite['basedir'] . '/wwwroot/sql/';
            }
        }
        else {
            if ($action == 'wadown') {
                $sql_exportDir = $vsite['basedir'] . '/webapps_backup/';
            }
            else {
                $sql_exportDir = $vsite['basedir'] . '/sql/';
            }
        }

        //
        //--- Handle exports:
        //

        if (($action == 'wadown') || ($action == 'down')) {
            $db_backup_file = $sql_exportDir . $db_name . '.sql';
            $filename = $db_name . '.sql';

            if (!is_file($db_backup_file)) {
                //file opening problems
                // Nice people say goodbye, or CCEd waits forever:
                $CI->cceClient->bye();
                $CI->serverScriptHelper->destructor();
                header("Location: /mysql/vsiteMySQL?group=" . $group);
                exit;
            }
            else {
                $target_db = read_file($db_backup_file);
                // Force download:
                $this->load->helper('download');
                force_download($filename, $target_db);
                // Nice people say goodbye, or CCEd waits forever:
                $CI->cceClient->bye();
                $CI->serverScriptHelper->destructor();
                header("Location: /mysql/vsiteMySQL?group=" . $group);
                exit;
            }
        }

        // Nice people say goodbye, or CCEd waits forever:
        $CI->cceClient->bye();
        $CI->serverScriptHelper->destructor();
        header("Location: /mysql/vsiteMySQL?group=" . $group);
        exit;

    }       
}
/*
Copyright (c) 2008-2020 Michael Stauber, SOLARSPEED.NET
Copyright (c) 2008-2020 Team BlueOnyx, BLUEONYX.IT
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/
?>