<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Mysqlconfig extends MX_Controller {

    /**
     * Index Page for this controller.
     *
     * Past the login page this loads the page for /mysql/mysqlconfig.
     *
     */

    public function index() {

        $CI =& get_instance();

        // We load the BlueOnyx helper library first of all, as we heavily depend on it:
        $this->load->helper('blueonyx');
        init_libraries();

        // Need to load 'BxPage' for page rendering:
        $this->load->library('BxPage');
        
        // Get $CI->BX_SESSION['sessionId'] and $CI->BX_SESSION['loginName'] from Cookie (if they are set):
        $CI->BX_SESSION['sessionId'] = $CI->input->cookie('sessionId');
        $CI->BX_SESSION['loginName'] = $CI->input->cookie('loginName');

        // Line up the ducks for CCE-Connection:
        include_once('ServerScriptHelper.php');
        $CI->serverScriptHelper = new ServerScriptHelper($CI->BX_SESSION['sessionId'], $CI->BX_SESSION['loginName']);
        $CI->cceClient = $CI->serverScriptHelper->getCceClient();
        $user = $CI->BX_SESSION['loginUser'];
        $i18n = new I18n("base-mysql", $CI->BX_SESSION['loginUser']['localePreference']);
        $system = $CI->getSystem();

        // Initialize Capabilities so that we can poll the access rights as well:
        $Capabilities = new Capabilities($CI->cceClient, $CI->BX_SESSION['loginName'], $CI->BX_SESSION['sessionId']);

        // -- Actual page logic start:

        // Not serverNetwork? Bye, bye!
        if (!$Capabilities->getAllowed('serverNetwork')) {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403");
        }

        //
        //--- Get CODB-Object of interest: 
        //

        $CODBDATA = $CI->cceClient->get($system['OID'], "MYSQLUSERS_DEFAULTS");

        //
        //--- Handle form validation:
        //

        // We start without any active errors:
        $errors = array();
        $extra_headers =array();
        $ci_errors = array();
        $my_errors = array();

        // Shove submitted input into $form_data after passing it through the XSS filter:
        $form_data = $CI->input->post(NULL, TRUE);

        // Form fields that are required to have input:
        $required_keys = array();
        // Set up rules for form validation. These validations happen before we submit to CCE and further checks based on the schemas are done:

        // Empty array for key => values we want to submit to CCE:
        $attributes = array();
        // Items we do NOT want to submit to CCE:
        $ignore_attributes = array("BlueOnyx_Info_Text", "_");
        if (is_array($form_data)) {
            // Function GetFormAttributes() walks through the $form_data and returns us the $parameters we want to
            // submit to CCE. It intelligently handles checkboxes, which only have "on" set when they are ticked.
            // In that case it pulls the unticked status from the hidden checkboxes and addes them to $parameters.
            // It also transformes the value of the ticked checkboxes from "on" to "1". 
            //
            // Additionally it generates the form_validation rules for CodeIgniter.
            //
            // params: $i18n                i18n Object of the error messages
            // params: $form_data           array with form_data array from CI
            // params: $required_keys       array with keys that must have data in it. Needed for CodeIgniter's error checks
            // params: $ignore_attributes   array with items we want to ignore. Such as Labels.
            // return:                      array with keys and values ready to submit to CCE.
            $attributes = GetFormAttributes($i18n, $form_data, $required_keys, $ignore_attributes, $i18n);
        }
        //Setting up error messages:
        $CI->form_validation->set_message('required', $i18n->get("[[palette.val_is_required]]", false, array("field" => "\"%s\"")));        

        // Do we have validation related errors?
        if ($CI->form_validation->run() == FALSE) {

            if (validation_errors()) {
                // Set CI related errors:
                $ci_errors = array(validation_errors('<div class="alert dismissible alert_red"><img width="40" height="36" src="/.adm/images/icons/small/white/alarm_bell.png"><strong>', '</strong></div>'));
            }           
            else {
                // No errors. Pass empty array along:
                $ci_errors = array();
            }
        }

        //
        //--- Own error checks:
        //

        if (is_file("/usr/libexec/mariadb-wait-ready")) {
            $my_cnf_file = "/etc/my.cnf.d/server.cnf";
        }
        else {
            $my_cnf_file = "/etc/my.cnf";
        }

        if ($CI->input->post(NULL, TRUE)) {
            $attributes['force_update'] = time();
            $my_cnf_out = $attributes['my_cnf'];
            unset($attributes['my_cnf']);

            // Write the new my.cnf:
            write_file("/tmp/my.cnf", $my_cnf_out);

            $diff = "0";
            if ((is_file("/usr/bin/diff")) && (is_file("/tmp/my.cnf"))) {
                $diff = `/usr/bin/diff $my_cnf_file /tmp/my.cnf | /usr/bin/wc -l`;
            }

            if ($diff != "0") {
                // If we want to activate the new my.cnf, we need to set "soltab" to "two".
                // Only then the handler will take care of it. But we only do so if the new
                // my.cnf's diff result is different from the existing /etc/my.cnf
                $attributes['soltab'] = "two";

                // Define who runs CCEwrap:
                $runas = 'root';
                $ret = $CI->serverScriptHelper->shell("/bin/cp /tmp/my.cnf $my_cnf_file", $nfk, 'root', $CI->BX_SESSION['sessionId']);
                $ret = $CI->serverScriptHelper->shell("/bin/chown root:root $my_cnf_file", $nfk, 'root', $CI->BX_SESSION['sessionId']);
                $ret = $CI->serverScriptHelper->shell("/bin/rm -f /tmp/my.cnf", $nfk, 'root', $CI->BX_SESSION['sessionId']);
            }
        }

        //
        //--- At this point all checks are done. If we have no errors, we can submit the data to CODB:
        //

        // Join the various error messages:
        $errors = array_merge($ci_errors, $my_errors);

        // If we have no errors and have POST data, we submit to CODB:
        if ((count($errors) == "0") && ($CI->input->post(NULL, TRUE))) {

            // We have no errors. We submit to CODB.

            // Actual submit to CODB:
            $CI->cceClient->set($system['OID'], "MYSQLUSERS_DEFAULTS",  $attributes);

            // CCE errors that might have happened during submit to CODB:
            $CCEerrors = $CI->cceClient->errors();
            foreach ($CCEerrors as $object => $objData) {
                // When we fetch the CCE errors it tells us which field it bitched on. And gives us an error message, which we can return:
                $errors[] = ErrorMessage($i18n->get($objData->message, true, array('key' => $objData->key)) . '<br>&nbsp;');
            }

            // No errors. Reload the entire page to load it with the updated values:
            if ((count($errors) == "0")) {
                header("Location: /mysql/mysqlconfig");
                exit;
            }
            else {
                $CODBDATA = $attributes;
            }
        }

        //
        //-- Own page logic:
        //

        //
        //-- Generate page:
        //


        // Prepare Page:
        $factory = $CI->serverScriptHelper->getHtmlComponentFactory("base-mysql", "/mysql/mysqlconfig");
        $BxPage = $factory->getPage();
        $BxPage->setErrors($errors);
        $i18n = $factory->getI18n();

        $product = new Product($CI->cceClient);

        // Set Menu items:
        $BxPage->setVerticalMenu('base_controlpanel');
        $BxPage->setVerticalMenuChild('base_mysqlconfig');
        $page_module = 'base_sysmanage';

        $defaultPage = "MySQL_TAB_ONE";

        $block =& $factory->getPagedBlock("mysql_header", array($defaultPage, 'MySQL_TAB_TWO'));

        $block->setToggle("#");
        $block->setSideTabs(FALSE);
        $block->setShowAllTabs("#");
        $block->setDefaultPage($defaultPage);

        //
        //--- MySQL_TAB_ONE
        //

        // Add MySQL userdb switch:
        $udb_switch = $CODBDATA['solsitemysql'];
        $block->addFormField(
          $factory->getBoolean("solsitemysql", $udb_switch),
          $factory->getLabel("udb_switch"),
          'MySQL_TAB_ONE'
        );

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_ZERO", ""),
                $factory->getLabel("DIVIDER_ZERO", false),
                $defaultPage
                );

        $my_TEXT = $i18n->getClean("[[base-mysql.MySQL_Info_Text]]");
        $mysql_info_text = $factory->getTextField("_", $my_TEXT, 'r');
        $mysql_info_text->setLabelType("nolabel");
        $block->addFormField(
            $mysql_info_text,
            $factory->getLabel(" "),
            'MySQL_TAB_ONE'
            );

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_ONE", ""),
                $factory->getLabel("DIVIDER_ONE", false),
                $defaultPage
                );

        $SELECT = $CODBDATA['SELECT'];
        $block->addFormField(
          $factory->getBoolean("SELECT", $SELECT),
          $factory->getLabel("SELECT"),
          'MySQL_TAB_ONE'
        );
        $INSERT = $CODBDATA['INSERT'];
        $block->addFormField(
          $factory->getBoolean("INSERT", $INSERT),
          $factory->getLabel("INSERT"),
          'MySQL_TAB_ONE'
        );
        $UPDATE = $CODBDATA['UPDATE'];
        $block->addFormField(
          $factory->getBoolean("UPDATE", $UPDATE),
          $factory->getLabel("UPDATE"),
          'MySQL_TAB_ONE'
        );
        $DELETE = $CODBDATA['DELETE'];
        $block->addFormField(
          $factory->getBoolean("DELETE", $DELETE),
          $factory->getLabel("DELETE"),
          'MySQL_TAB_ONE'
        );
        //$FILE = $CODBDATA['FILE'];
        //$block->addFormField(
        //  $factory->getBoolean("FILE", $FILE),
        //  $factory->getLabel("FILE"),
        //  'MySQL_TAB_ONE'
        //);

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_TWO", ""),
                $factory->getLabel("DIVIDER_TWO", false),
                $defaultPage
                );

        $CREATE = $CODBDATA['CREATE'];
        $block->addFormField(
          $factory->getBoolean("CREATE", $CREATE),
          $factory->getLabel("CREATE"),
          'MySQL_TAB_ONE'
        );
        $ALTER = $CODBDATA['ALTER'];
        $block->addFormField(
          $factory->getBoolean("ALTER", $ALTER),
          $factory->getLabel("ALTER"),
          'MySQL_TAB_ONE'
        );
        $INDEX = $CODBDATA['INDEX'];
        $block->addFormField(
          $factory->getBoolean("INDEX", $INDEX),
          $factory->getLabel("INDEX"),
          'MySQL_TAB_ONE'
        );
        $DROP = $CODBDATA['DROP'];
        $block->addFormField(
          $factory->getBoolean("DROP", $DROP),
          $factory->getLabel("DROP"),
          'MySQL_TAB_ONE'
        );
        $TEMPORARY = $CODBDATA['TEMPORARY'];
        $block->addFormField(
          $factory->getBoolean("TEMPORARY", $TEMPORARY),
          $factory->getLabel("TEMPORARY"),
          'MySQL_TAB_ONE'
        );

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_THREE", ""),
                $factory->getLabel("DIVIDER_THREE", false),
                $defaultPage
                );

        // Old code had a check here for version of MySQL, as these functions require MySQL5.
        // Even 5106R now has MySQL5, so we can forego the check:
        $access = 'rw';

        $CREATE_VIEW = $CODBDATA['CREATE_VIEW'];
        $block->addFormField(
          $factory->getBoolean("CREATE_VIEW", $CREATE_VIEW, $access),
          $factory->getLabel("CREATE_VIEW"),
          'MySQL_TAB_ONE'
        );
        $SHOW_VIEW = $CODBDATA['SHOW_VIEW'];
        $block->addFormField(
          $factory->getBoolean("SHOW_VIEW", $SHOW_VIEW, $access),
          $factory->getLabel("SHOW_VIEW"),
          'MySQL_TAB_ONE'
        );
        $CREATE_ROUTINE = $CODBDATA['CREATE_ROUTINE'];
        $block->addFormField(
          $factory->getBoolean("CREATE_ROUTINE", $CREATE_ROUTINE, $access),
          $factory->getLabel("CREATE_ROUTINE"),
          'MySQL_TAB_ONE'
        );
        $ALTER_ROUTINE = $CODBDATA['ALTER_ROUTINE'];
        $block->addFormField(
          $factory->getBoolean("ALTER_ROUTINE", $ALTER_ROUTINE, $access),
          $factory->getLabel("ALTER_ROUTINE"),
          'MySQL_TAB_ONE'
        );
        $EXECUTE = $CODBDATA['EXECUTE'];
        $block->addFormField(
          $factory->getBoolean("EXECUTE", $EXECUTE, $access),
          $factory->getLabel("EXECUTE"),
          'MySQL_TAB_ONE'
        );

        // New additions:
        $EVENT = $CODBDATA['EVENT'];
        $block->addFormField(
          $factory->getBoolean("EVENT", $EVENT, $access),
          $factory->getLabel("EVENT"),
          'MySQL_TAB_ONE'
        );
        $TRIGGER = $CODBDATA['TRIGGER'];
        $block->addFormField(
          $factory->getBoolean("TRIGGER", $TRIGGER, $access),
          $factory->getLabel("TRIGGER"),
          'MySQL_TAB_ONE'
        );

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_ADM", ""),
                $factory->getLabel("DIVIDER_ADM", false),
                $defaultPage
                );
        $GRANT = $CODBDATA['GRANT'];
        $block->addFormField(
          $factory->getBoolean("GRANT", $GRANT, 'r'),
          $factory->getLabel("GRANT"),
          'MySQL_TAB_ONE'
        );
        $LOCK_TABLES = $CODBDATA['LOCK_TABLES'];
        $block->addFormField(
          $factory->getBoolean("LOCK_TABLES", $LOCK_TABLES, $access),
          $factory->getLabel("LOCK_TABLES"),
          'MySQL_TAB_ONE'
        );
        $REFERENCES = $CODBDATA['REFERENCES'];
        $block->addFormField(
          $factory->getBoolean("REFERENCES", $REFERENCES, $access),
          $factory->getLabel("REFERENCES"),
          'MySQL_TAB_ONE'
        );

        // Add divider:
        $block->addFormField(
                $factory->addBXDivider("DIVIDER_FOUR", ""),
                $factory->getLabel("DIVIDER_FOUR", false),
                $defaultPage
                );

        $MAX_QUERIES_PER_HOUR =& $factory->getInteger("MAX_QUERIES_PER_HOUR", $CODBDATA['MAX_QUERIES_PER_HOUR'], 0, 50000000);
        $MAX_QUERIES_PER_HOUR->showBounds(1);
        $MAX_QUERIES_PER_HOUR->setWidth(8);
        $block->addFormField(
            $MAX_QUERIES_PER_HOUR,
            $factory->getLabel('MAX_QUERIES_PER_HOUR'),
            'MySQL_TAB_ONE'
            );

        $MAX_CONNECTIONS_PER_HOUR =& $factory->getInteger("MAX_CONNECTIONS_PER_HOUR", $CODBDATA['MAX_CONNECTIONS_PER_HOUR'], 0, 50000000);
        $MAX_CONNECTIONS_PER_HOUR->showBounds(1);
        $MAX_CONNECTIONS_PER_HOUR->setWidth(8);
        $block->addFormField(
            $MAX_CONNECTIONS_PER_HOUR,
            $factory->getLabel('MAX_CONNECTIONS_PER_HOUR'),
            'MySQL_TAB_ONE'
            );

        $MAX_UPDATES_PER_HOUR =& $factory->getInteger("MAX_UPDATES_PER_HOUR", $CODBDATA['MAX_UPDATES_PER_HOUR'], 0, 50000000);
        $MAX_UPDATES_PER_HOUR->showBounds(1);
        $MAX_UPDATES_PER_HOUR->setWidth(8);
        $block->addFormField(
            $MAX_UPDATES_PER_HOUR,
            $factory->getLabel('MAX_UPDATES_PER_HOUR'),
            'MySQL_TAB_ONE'
            );

        //
        //--- MySQL_TAB_TWO
        //

        $the_file_data = file_get_contents("$my_cnf_file");
        $block->addFormField(
          $factory->getTextBlock("my_cnf", $the_file_data),
          $factory->getLabel("my_cnf"),
          'MySQL_TAB_TWO'
        );

        //
        //--- Add the buttons
        //

        $block->addButton($factory->getSaveButton($BxPage->getSubmitAction()));
        $block->addButton($factory->getCancelButton("/mysql/mysqlconfig"));

        $page_body[] = $block->toHtml();

        // Out with the page:
        $BxPage->render($page_module, $page_body);

    }       
}

/*
Copyright (c) 2015 Michael Stauber, SOLARSPEED.NET
Copyright (c) 2015 Team BlueOnyx, BLUEONYX.IT
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/
?>